### Spark-Scheduler #

Repository for the Spark/YARN scheduler.

## Compile and Run:
*ensure updated rest.dn is used for a single machine*

Within the *Spark-Scheduler* directory, to compile enter the following command:

`dnc .`

OR

`dnc [filename].dn`

## [For a single machine] Within the *spark-scheduler* directory enter the following to run:

`dana pal.rest -p [port number for pal.rest] [filename].o`

## [For a cluster of machines] Within the *spark-scheduler* directory enter the following to run:

`dana pal.rest ./[filename].o`


ALTERNATIVELY

On a Linux Operating System you may use aliases for starting the Resource Manager [Master] and Node Managers [Workers] nodes:

Access the .\bashrc:
`nano .\bashrc`

Place the following into .\bashrc for:

[Master Node]: `alias resourceManager='cd <YourHomeDirectory>/spark-scheduler && dana pal.rest ./ResourceManager.o'`


[Worker Node]: `alias nodeManager='cd <YourHomeDirectory>/spark-scheduler && dana pal.rest ./NodeManager.o'`

Rehresh environment variables within the bashrc:
`source ~/.bashrc`

You may now launch a Resource/Node manager by entering the following commands:
Master node: `resourceManager`
Worker node: `nodeManager`

### Submit Applications using TCPClient.dn

## For individual applications:
`dana .\TCPClient.o ~driver-cores <int >= 1 for number of threads> ~driver-me
mory <int >=1 for Gigabytes with apppended g> ~executor-memory <int >=1 for Gigabytes with apppended g> ~executor-cores <int >= 1 for number of threads> ~num-executors <limit for number of executors> ~applica
tion-name <User defined name consiting of char/integers> ~application-dn <dir containing the applicaion.o on the worker nodes>  
~num-partitions <int defining number of task to be created> ~application-data <location of input data for application[Required but not used]>\Input-Data\AliceDTRH.txt`

# For example:
` dana .\TCPClient.o ~driver-cores 1 ~driver-memory 2g ~executor-memory 2g ~executor-cores 2 ~num-executors 2
~application-name AppFG4 ~application-dn Workloads/FG-W-v2/CG-6min.o ~num-partitions 5 ~application-data \Input-Data\AliceDTRH.txt`

The above command will create an Application Master with a reservation of 1 thread and 2 gigabytes of memory, with a maximum of 2 executors allowed to run concurrently across the cluster with
the reservation of 2 threads and 2 gigabytes of memory each. The application to be run is "CG-6min.o", the application will be performed 5 times across executors

## For the submission of a workload[for more detailed information on the format of a Workload see Workloads\README-Workload]:

	 'dana .\TCPClient.o wkld <directory containing [yourWorkload.txt]>'
# For example:
	 'dana .\TCPClient.o wkld .\Workloads\test\TW-FG.txt'

The above command will submit the workload TW-FG.txt from the "test" to the Resource Manager [see Workloads\test\test-V2\TW-FG.txt for an example].
NOTE: Ensure each application in the workload is on a new line and there is no additional whitespace at the end of the .txt  file containing the workload
